/**
 * @function _bud
 */
"use strict";

const stringcase = require('stringcase'),
    _tmpl = require('./_tmpl'),
    pkg = require('../package.json'),
    path = require('path');

/** @lends _bud */
function _bud(type, name, params) {
    let tmpl = _tmpl(type, name);
    return {
        force: false,
        mode: '644',
        mkdirp: true,
        path: params.filename || ((dirname, basename)=> {
            let suffix = params.suffix,
                prefix = params.prefix,
                extname = params.extname || '.jsx';
            if (prefix) {
                basename = [prefix, basename].join('_');
            }
            if (suffix) {
                basename = [basename, suffix].join('_');
            }
            return `${dirname}/${stringcase.snakecase(basename)}${extname}`;
        })(path.dirname(name), path.basename(name)),
        tmpl: tmpl,
        data: {
            params: params,
            name: path.basename(name),
            base: params.base || name.replace(/^\./, '').split('/').map(()=>'..').join('/'),
            type: type,
            generator: 'coz',
            today: new Date().toLocaleDateString(),
            pkg: pkg
        }
    }
}

module.exports = _bud;