/**
 * @function _tmpl
 * @private
 */

"use strict";

const fs = require('fs'),
    assert = require('assert'),
    stringcase = require('stringcase'),
    types = require('./types');

/** @lends _tmpl */
function _tmpl(type, name) {

    let filename = ((keys)=> {
        for (let key of keys) {
            let found = types[key] || types[stringcase.camelcase(key)];
            if (found) {
                return found;
            }
        }
        return types.default;
    })([[name, type].join('_'), [type, name].join('_'), type]);
    return fs.readFileSync(__dirname + '/../' + filename).toString();
}

module.exports = _tmpl;
