/**
 * Test case for index.
 * Runs with mocha.
 */
"use strict";

const index = require('../lib/index.js'),
    assert = require('assert'),
    coz = require('coz');

describe('index', () => {

    before((done) => {
        done();
    });

    after((done) => {
        done();
    });


    it('Render view', (done) => {
        let bud = index.view([
            'SplashTop',
            'AccountDetail'
        ]);
        assert.ok(bud);
        bud.forEach((bud) => {
            assert.ok(bud.tmpl);
            bud.path = __dirname + '/../tmp/index/view/' + bud.path;
            bud.mkdirp = true;
            bud.force = true;
        });
        coz.render(bud, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Render page', (done) => {
        let bud = index.page([
            'Splash'
        ]);
        assert.ok(bud);
        bud.forEach((bud) => {
            assert.ok(bud.tmpl);
            bud.path = __dirname + '/../tmp/index/page/' + bud.path;
            bud.mkdirp = true;
            bud.force = true;
        });
        coz.render(bud, (err) => {
            assert.ifError(err);
            done();
        });
    });

    it('Render fragment', (done) => {
        let bud = index.fragment([
            'foo/bar'
        ]);
        assert.ok(bud);
        bud.forEach((bud) => {
            assert.ok(bud.tmpl);
            bud.path = __dirname + '/../tmp/index/fragment/' + bud.path;
            bud.mkdirp = true;
            bud.force = true;
        });
        coz.render(bud, (err) => {
            assert.ifError(err);
            done();
        });
    });
});

